<?php
/*
 * @package admin
 * @copyright Copyright 2003-2012 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: Links Manager 3.5.3 4/16/2010 Clyde Jones $
 *
 * @version $id: init_links_manager.php 3.7.0 5/14/2016 davewest $
 */

/*
 * configure Link Manager
*/

  if (!defined('IS_ADMIN_FLAG')) {
    die('Illegal Access');
  }   

// do not run installer on log in page or if already at current version
 if (!(basename($PHP_SELF) == FILENAME_LOGIN . ".php")) {
 
      // set version
        $version = '3.7.0';
     // Get db prefix if any
 	$db_prefix = DB_PREFIX;       
     // if already installed  
      $current_version = LM_VERSION;
      
    // Set table name
 	$table_name = $db_prefix . 'links';
	$table_name2 = $db_prefix . 'links_description';
	$table_name3 = $db_prefix . 'links_status';
	$table_name4 = $db_prefix . 'links_to_link_categories';
	$table_name5 = $db_prefix . 'link_categories';
	$table_name6 = $db_prefix . 'link_categories_description';

if ($current_version != $version) {
 


// set the words holder
$isit_installed = '';

        
    // Screen activity
 	$isit_installed = 'Links Manager v' . $version . ' for ZenCart Installing...<br/>';
  
     // Configuration Values to create or preserve
    $menu_items_image = array(
            array('Links Box - Display View All Links','BOX_DISPLAY_VIEW_ALL_LINKS','true','Display View All Links on Links Sidebox',1001,array('true', 'false')),
            array('Links Box - Display Submit Link','BOX_DISPLAY_SUBMIT_LINK','true','Display Submit Link on Sidebox',1002,array('true', 'false')),
            array('Display Description As Link','DISPLAY_LINK_DESCRIPTION_AS_LINK','false','Display the links description as a link',1003,array('true', 'false')),
            array('Submit Link - Require Reciprocal Page', 'SUBMIT_LINK_REQUIRE_RECIPROCAL', 'true', 'Require Reciprocal Page on Links Submit',1004,array('true', 'false')),
            array('Display Link Banner Image','LINK_LIST_IMAGE',1,'Do you want to display the Link Banner Image?',1005,array('0', '1', '2', '3')),
            array('Display Link Description', 'LINK_LIST_DESCRIPTION', 2, 'Do you want to display the Link Description?',1006,array('0', '1', '2', '3')),
            array('Display Link Click Count', 'LINK_LIST_COUNT', 3, 'Do you want to display the Link Click Count?',1007,array('0', '1', '2', '3')),
            array('Link Title Minimum Length', 'ENTRY_LINKS_TITLE_MIN_LENGTH', 2, 'Minimum length of link title.',1008,false),
            array('Link Title Maximum Length', 'ENTRY_LINKS_TITLE_MAX_LENGTH', 50, 'Maximum length of link title.',1009,false),
            array('Link URL Minimum Length', 'ENTRY_LINKS_URL_MIN_LENGTH', 10, 'Minimum length of link URL.',1010,false),
            array('Link Description Minimum Length', 'ENTRY_LINKS_DESCRIPTION_MIN_LENGTH', 10, 'Minimum length of link description.',1011,false),
            array('Link Description Maximum Length', 'ENTRY_LINKS_DESCRIPTION_MAX_LENGTH', 250, 'Maximum length of link description.',1012,false),
            array('Link Contact Name Minimum Length', 'ENTRY_LINKS_CONTACT_NAME_MIN_LENGTH', 2, 'Minimum length of link contact name.',1013,false),
            array('Number Of Links to display on Links Page', 'MAX_DISPLAY_LINKS', 15, 'Set the number of Links to display on the Links page.',1014,false),
            array('Links Check Phrase', 'LINKS_CHECK_PHRASE', 'yoursitename', 'Phrase to look for when you perform a link check.',1015,false),
            array('Links List - Scroll Box Size/Style', 'MAX_LINKS_LIST', 3, 'Number of link category names to be displayed in the scroll box window. Setting this to 1 or 0 will display a dropdown list',1016,false),
            array('Length of Link Categories Name', 'MAX_DISPLAY_LINK_NAME_LEN', 17, 'Used in links box; maximum length of link category name to display. Longer names will be truncated.',1017,false),
            array('Select Links Sort Order', 'DEFINE_SORT_ORDER', 1, 'Define the sort order of the links<br />1= Sort by Title<br />2= Sort by Date (Newest to Oldest)<br />3= Sort by number of clicks (highest to lowest)',1018,array('1', '2', '3')),
            array('Number of Link Categories Per Row - Default is 3', 'MAX_LINK_CATEGORIES_ROW', 3, 'Used to display Link Categories per row.<br />Default is 3',1019,false),
            array('Link Category Image Directory', 'LINK_CATEGORY_IMAGE_DIRECTORY', 'link_category/', 'Set the Directory for the Category Image',1020,false),
            array('Image - Link Category Height', 'LINK_CATEGORY_IMAGE_HEIGHT', 80, 'The pixel width of Link Category images',1021,false),
            array('Image - Link Category Width', 'LINK_CATEGORY_IMAGE_WIDTH', 80, 'The pixel width of Link Category images',1022,false),
            array('Show Banner Image Field', 'SHOW_LINKS_BANNER_IMAGE', 'true', 'Show Banner Image Field',1023,array('true', 'false')),
            array('Link Banner Image Directory', 'LINK_IMAGE_DIRECTORY', 'links_image/', 'Set the Directory for the Link Image',1024,false),
            array('Image - Link Banner Image Width', 'LINK_IMAGE_WIDTH', 150, 'The pixel width of Link images',1025,false),
            array('Image - Link Banner Image Height', 'LINK_IMAGE_HEIGHT', 30, 'The pixel height of Link images',1026,false),
            array('Default Link Banner Image', 'DEFAULT_LINK_IMAGE', 'links_default.jpg', 'Set the Default Link Image',1027,false),
            array('Only registered customers may submit a Link', 'REGISTERED_LINK', 'false', 'Only registered customers may submit a Link',1028,array('true', 'false')),
            array('Links - Show Store Name and Address', 'LINKS_STORE_NAME_ADDRESS', 'true', 'Include Store Name and Address',1029,array('true', 'false')),
            array('Define Links Status', 'DEFINE_LINKS_STATUS', 1, 'Enable the Defined Link/Text?<br />0= Link ON, Define Text OFF<br />1= Link ON, Define Text ON<br />2= Link OFF, Define Text ON<br />3= Link OFF, Define Text OFF',1030,array('0', '1', '2', '3')),
            array('Use Click Count!', 'USE_CLICK_COUNT', 1, 'Create link URL with or without click counting  0= off 1= on',1031,array('1', '0')),
            array('Link list display as 0=Tabular or 1=Columnar style!','LINK_LIST_DISPLAY',1,'Display links in 0=Tabular or 1=Columnar style!',1032,array('0', '1')),
            array('Number of Links Per Row for Columnar Display - Default is 3', 'MAX_LINKS_ROW', 3, 'Used to display Links per row for Columnar Display only.<br />Default is 3',1033,false),
            array('Links Manager Version', 'LM_VERSION', $version, 'Links Manager version',2000,false)
            );
            
         // Legacy Configuration Values to Delete Completely
        $menu_items_delete = array(
            array('LINK_LIST_COUNT')
            );
            
                   
// Create new Configuration Category
	$check_result = $db->Execute("SELECT 'configuration_group_id' FROM ". TABLE_CONFIGURATION_GROUP . " WHERE configuration_group_title = 'Links Manager' LIMIT 0, 300 ");
	if ($check_result->RecordCount() > 1) die('To Many Groups - Run remove and Clean your database then try again!');
	if ($check_result->RecordCount() < 1) {
	
	  $insert_result1 = $db->Execute("INSERT INTO ". TABLE_CONFIGURATION_GROUP . " VALUES ('', 'Links Manager', 'Links Display Settings', '0', '1')");
	  $db->Execute("UPDATE ". TABLE_CONFIGURATION_GROUP . " SET sort_order = LAST_INSERT_ID() WHERE configuration_group_id = LAST_INSERT_ID()");
          $categoryid = $db->Execute("SELECT configuration_group_id FROM ". TABLE_CONFIGURATION_GROUP . " WHERE configuration_group_title = 'Links Manager'");
	if ($insert_result1 === false) exit ('Error in Createing New Configuration Group - Links Manager<br/> ');
	if ($insert_result1) $isit_installed .= 'Created New Configuration Group - Links Manager<br/>';			 
	} else {
		$isit_installed .= 'Configuration Group Links Manager already exists SKIPPED<br/>';
	}
	
// Get the id of the new configuration category
    $categoryid = array();
	$id_result = $db->Execute("SELECT configuration_group_id FROM ". TABLE_CONFIGURATION_GROUP . " WHERE configuration_group_title = 'Links Manager'");
	if (!$id_result->EOF) {
			$categoryid = $id_result->fields;
			$isit_installed .= 'Links Manager Configuration_Group ID = ' . $categoryid['configuration_group_id']. '<br>';
			$lm_config_id = $categoryid['configuration_group_id'];
    } else {
    	    exit ('Failed Finding Links Manager Configuration_Group ID<br/>Exit');
    }
    

 // delete legacy configuration options

    foreach($menu_items_delete as $del)
    {

       $sql ="DELETE FROM ".TABLE_CONFIGURATION." WHERE configuration_key = '".$del[0]."'";
       $db->Execute($sql);
        
    }
    
    foreach($menu_items_image as $menu_item)
    {
    lm_create_menu_item($menu_item[0],$menu_item[1],$menu_item[2],$menu_item[3],$lm_config_id,$menu_item[4],$menu_item[5]);
    }
    
    //$over_item = array('Links Manager Version', 'LM_VERSION', '3.6.1', 'Links Manager version',1031,false);
   // lm_overwrite_menu_item($over_item[0],$over_item[1],$over_item[2],$over_item[3],$lm_config_id,$over_item[4],$over_item[5]);

 // register LM admin pages for Zen 1.5.x

    if (function_exists('zen_register_admin_page')) {

        zen_deregister_admin_pages('Links');
        zen_register_admin_page('Links', 'BOX_LINKS', 'FILENAME_LINKS', '', 'extras', 'Y', 101);
    
	zen_deregister_admin_pages('LinksCategories');
        zen_register_admin_page('LinksCategories', 'BOX_LINK_CATEGORIES', 'FILENAME_LINK_CATEGORIES', '', 'extras', 'Y', 102);
    
	zen_deregister_admin_pages('LinksContacts');
        zen_register_admin_page('LinksContacts', 'BOX_LINKS_CONTACT', 'FILENAME_LINKS_CONTACT', '', 'extras', 'Y', 103);
    
    zen_deregister_admin_pages('LinkDisplay');
    zen_register_admin_page('LinkDisplay', 'BOX_CONFIGURATION_LINKMANAGER', 'FILENAME_CONFIGURATION', 'gID='. $lm_config_id . '', 'configuration', 'Y', 200);
    
       $isit_installed .= 'Admin pages created for ZC 1.5.x<br />';

    } 

/*************** Links Table ***********************/

            // check to see if table exists
            $result=lm_table_exists($table_name);
            if ($result==true) {
                 $isit_installed .= 'table '. $table_name .' is already installed.<br>';
            } else {

      		$insert_query = "CREATE TABLE `".$table_name."` (
      		links_id int(11) NOT NULL auto_increment,
      		links_url varchar(255) default NULL,
      		links_reciprocal_url varchar(255) default NULL,
      		links_image_url varchar(255) default NULL,
      		links_contact_name varchar(64) default NULL,
      		links_contact_email varchar(96) default NULL,
      		links_date_added datetime NOT NULL default '0000-00-00 00:00:00',
      		links_last_modified datetime default NULL,
      		links_status tinyint(1) NOT NULL default '1',
      		links_clicked int(11) NOT NULL default '0',
      		PRIMARY KEY  (links_id),
      		KEY idx_links_date_added (links_date_added)
      		);";
      		
      		@$insert_result = $db->Execute($insert_query);
      		 
      		 $db->Execute("INSERT INTO ".$table_name." VALUES (1, 'http://clydedesigns.com', 'http://clydedesigns.com', 'links_image/testsite.jpg', 'Clyde Jones', 'clydejones@hotmail.com', now(), NULL, 2, 0)");
      		 
		$isit_installed .= 'Table ' .$table_name. ' installed!<br />'; 
}	
		
/******************** links_description ***************************/
            // check to see if table exists
            $result=lm_table_exists($table_name2);
            if ($result==true) {
                 $isit_installed .= 'table '. $table_name2 .' is already installed.<br>';
            } else {
            
      		$insert_query = "CREATE TABLE `".$table_name2."` (
      		links_id int(11) NOT NULL auto_increment,
      		language_id int(11) NOT NULL default '1',
      		links_title varchar(64) NOT NULL default '',
      		links_description text,
      		PRIMARY KEY  (links_id,language_id),
      		KEY links_title (links_title)
      		);";
      		
      		@$insert_result = $db->Execute($insert_query);
      	        
      	        $db->Execute("INSERT INTO ".$table_name2." VALUES (1, 1, 'Clyde Designs', 'Templates &amp; Add-Ons for Zen Cart&trade;')");
      	         
		$isit_installed .= 'Table ' .$table_name2. ' installed!<br />'; 
} 	
   
/******************* links_status **************************/
            // check to see if table exists
            $result=lm_table_exists($table_name3);
            if ($result==true) {
                 $isit_installed .= 'table '. $table_name3 .' is already installed.<br>';
            } else {
            
      		$insert_query = "CREATE TABLE `".$table_name3."` (
      		links_status_id int(11) NOT NULL default '0',
      		language_id int(11) NOT NULL default '1',
      		links_status_name varchar(32) NOT NULL default '',
      		PRIMARY KEY  (links_status_id,language_id),
      		KEY idx_links_status_name (links_status_name)
      		);";

      		@$insert_result = $db->Execute($insert_query);
      		
      		$db->Execute("INSERT INTO ".$table_name3." VALUES (1, 1, 'Pending'),(2, 1, 'Approved'),(3, 1, 'Blocked')");   //links_status
      		
		$isit_installed .= 'Table ' .$table_name3. ' installed!<br />'; 
} 	
   
/*************** links_to_link_categories *******************************/
            // check to see if table exists
            $result=lm_table_exists($table_name4);
            if ($result==true) {
                 $isit_installed .= 'table '. $table_name4 .' is already installed.<br>';
            } else {
            
      		$insert_query = "CREATE TABLE `".$table_name4."` (
      		links_id int(11) NOT NULL auto_increment,
      		link_categories_id int(11) NOT NULL default '0',
      		PRIMARY KEY  (links_id,link_categories_id)
      		);";
      		
      		@$insert_result = $db->Execute($insert_query);
      		
      		$db->Execute("INSERT INTO ".$table_name4." VALUES (1, 1)"); 
      		
		$isit_installed .= 'Table ' .$table_name4. ' installed!<br />'; 
} 	
   
/**************** link_categories ****************************/
            // check to see if table exists
            $result=lm_table_exists($table_name5);
            if ($result==true) {
                 $isit_installed .= 'table '. $table_name5 .' is already installed.<br>';
            } else {
            
      		$insert_query = "CREATE TABLE `".$table_name5."` (
      		link_categories_id int(11) NOT NULL auto_increment,
      		link_categories_image varchar(64) default NULL,
      		link_categories_sort_order int(3) default NULL,
      		link_categories_date_added datetime default NULL,
      		link_categories_last_modified datetime default NULL,
      		link_categories_status tinyint(1) NOT NULL default '0',
      		 PRIMARY KEY  (link_categories_id),
      		 KEY idx_link_categories_date_added (link_categories_date_added)
      		);";
      		
      		@$insert_result = $db->Execute($insert_query);
      		
      		$db->Execute("INSERT INTO ".$table_name5." VALUES (1, 'link_category/zencart.png', 1, now($default), NULL, 1)");
      		
		$isit_installed .= 'Table ' .$table_name5. ' installed!<br />'; 
} 
   
/**************** link_categories_description ****************************/
            // check to see if table exists
            $result=lm_table_exists($table_name6);
            if ($result==true) {
                 $isit_installed .= 'table '. $table_name6 .' is already installed.<br>';
            } else {
            
      		$insert_query = "CREATE TABLE `".$table_name6."` (
      		link_categories_id int(11) NOT NULL default '1',
      		language_id int(11) NOT NULL default '1',
      		link_categories_name varchar(40) NOT NULL default '',
      		link_categories_description text,
      		PRIMARY KEY  (link_categories_id,language_id),
      		 KEY idx_link_categories_name (link_categories_name)
      		);";
      		
      		@$insert_result = $db->Execute($insert_query);
      		
      		$db->Execute("INSERT INTO ".$table_name6." VALUES (1, 1, 'Zen-Cart Development', '')");
      		
		$isit_installed .= 'Table ' .$table_name6. ' installed!<br />'; 
} 	
   

/**************** update status if needed *****************/

	 // $check_status = ;
	  $check_result = $db->Execute("SELECT links_status_name FROM ".$table_name3." WHERE links_status_name = 'Blocked'");
      if ($check_result->fields['links_status_name'] == '')  { //fixed 6/29/2014 change from 0 to 1
      
           $db->Execute("INSERT INTO ".$table_name3." VALUES (3, 1, 'Blocked')");   //links_status
           
	   $isit_installed .= 'Table ' . $table_name3 .' updated with Blocked!<br />';
	}
/************** done lets get out of here ***********  
 * The following code would normaly delete the auto-loader
 * Why!!  this mod is smarter so no need to delete
 * To re-install for making changes to the config's click the check-for-update button and the code runs again if the version is new..
**/


echo $isit_installed . '<br /> DONE';

//if on login page pass all code, if current installed version matches, pass all code no need to delete the autoloader ever
 }
}


/****************************************************************/
// create config menu item function

    function lm_create_menu_item($c_title,$c_key,$default,$discrip,$config_id,$sort,$values)
    {
            global $db;
            $sql = "SELECT configuration_value FROM ".TABLE_CONFIGURATION." WHERE configuration_key = '".$c_key."' LIMIT 1";
            $results = $db->Execute($sql);
            
            $config_value = ($results->fields['configuration_value'] !='')?$results->fields['configuration_value']: $default;

            $sql ="DELETE FROM ".TABLE_CONFIGURATION." WHERE configuration_key = '".$c_key."'";
            $db->Execute($sql);


            if($values)
            {
                foreach($values as $v)
                {
                $v_string .= "''".$v."'',";
                }
                $v_arr = substr($v_string,0,-1);
                $sql = "INSERT INTO ".TABLE_CONFIGURATION." (configuration_id, configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, last_modified, date_added, use_function, set_function) VALUES (NULL, '".$c_title."', '".$c_key."', '".$default."', '".$discrip."', ".$config_id.", ".$sort.", now(), now(), NULL, 'zen_cfg_select_option(array(".$v_arr."),')";
            }else{
                // text input type
                $sql = "INSERT INTO ".TABLE_CONFIGURATION." (configuration_id, configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, last_modified, date_added, use_function, set_function) VALUES (NULL, '".$c_title."', '".$c_key."', '".$default."', '".$discrip."', ".$config_id.", ".$sort.", now(), now(), NULL, NULL)";
            }
    
            //echo $sql . '<br />'; 
            $db->Execute($sql);  



            return true;

    }

// overwrite config menu item function

 /*   function lm_overwrite_menu_item($c_title,$c_key,$default,$discrip,$config_id,$sort,$values)
    {
            global $db;
            $sql ="DELETE FROM ".TABLE_CONFIGURATION." WHERE configuration_key = '".$c_key."'";
            $db->Execute($sql);

            if($values)
            {
                foreach($values as $v)
                {
                $v_string .= "''".$v."'',";
                }
                $v_arr = substr($v_string,0,-1);
                $sql = "INSERT INTO ".TABLE_CONFIGURATION." (configuration_id, configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, last_modified, date_added, use_function, set_function) VALUES (NULL, '".$c_title."', '".$c_key."', '".$default."', '".$discrip."', ".$config_id.", ".$sort.", now(), now(), NULL, 'zen_cfg_select_option(array(".$v_arr."),')";
            }else{
                // text input type
                $sql = "INSERT INTO ".TABLE_CONFIGURATION." (configuration_id, configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, last_modified, date_added, use_function, set_function) VALUES (NULL, '".$c_title."', '".$c_key."', '".$default."', '".$discrip."', ".$config_id.", ".$sort.", now(), now(), NULL, NULL)";
            }
    
            $db->Execute($sql);  



            return true;

    } */
if (!function_exists('lm_field_exists')) { 
  function lm_field_exists($table,$field) {
   global $db;
    $sql = "show fields from " . $table;
    $result = $db->Execute($sql);
    while (!$result->EOF) {
    // echo 'fields found='.$result->fields['Field'].'<br />';
      if  ($result->fields['Field'] == $field) {
        return true; // exists, so return with no error
      }
      $result->MoveNext();
    }
    return false;
  }
}

if (!function_exists('lm_table_exists')) { 
  function lm_table_exists($table_name) {
    global $db;
    $found_table = false;
    // Check to see if the requested Zen Cart table exists
    $sql = "SHOW TABLES like '".$table_name."'";
    $tables = $db->Execute($sql);
    //echo 'tables_found = '. $tables->RecordCount() .'<br>';
    if ($tables->RecordCount() > 0) {
      $found_table = true;
    }
    return $found_table;
  }
}
?>
  
