<?php
/**
 * Links Listing
 *
 * @package templateSystem
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
  **********************************************************************
 *This program is distributed in the hope that it will be useful, but
 *WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
**********************************************************************
 * @version $Id: link_listing.php 3.5.3 4/16/2010 Clyde Jones $
 *
 * @version $id: link_listing.php 3.7.0 5/14/2016 davewest $
 */

// check sort order
//$sortorder = "ld.links_title";	
if (DEFINE_SORT_ORDER == 1) $sortorder = "ld.links_title"; 
if (DEFINE_SORT_ORDER == 2) $sortorder = "l.links_date_added desc"; 
if (DEFINE_SORT_ORDER == 3) $sortorder = "l.links_clicked desc"; 

// show the links in a given category
// We show them all
    $listing_sql = "select " . $select_column_list . " l.links_id from " . TABLE_LINKS_DESCRIPTION . " ld, " . TABLE_LINKS . " l, " . TABLE_LINKS_TO_LINK_CATEGORIES . " l2lc where l.links_status = '2' and l.links_id = l2lc.links_id and ld.links_id = l2lc.links_id and ld.language_id = '" . (int)$_SESSION['languages_id'] . "' and l2lc.link_categories_id = '" . (int)$current_category_id . "'" . "order by $sortorder";


  $listing_split = new splitPageResults($listing_sql, MAX_DISPLAY_LINKS, 'l.links_id');

  if ( ($listing_split->number_of_rows > 0) && ( (PREV_NEXT_BAR_LOCATION == '1') || (PREV_NEXT_BAR_LOCATION == '3') ) ) {
?>
<div>
    <div class="smallText"><?php echo $listing_split->display_count(TEXT_DISPLAY_NUMBER_OF_LINKS); ?></div>
    <div class="smallText" align="right"><?php echo TEXT_RESULT_PAGE . ' ' . $listing_split->display_links(MAX_DISPLAY_PAGE_LINKS, zen_get_all_get_params(array('page', 'info', 'x', 'y'))); ?></div>
</div>
<?php
  }

//start
  if ($listing_split->number_of_rows > 0) {
    if(LINK_LIST_DISPLAY == 0) {  //tabular display
    $rows = 0;
    $listing_query = $db->Execute($listing_split->sql_query);
  ?>
     <table border="0" width="100%" cellspacing="0" cellpadding="0" id="myAccountOrdersStatus" summary="Table contains the date, order status and any comments regarding the order">
  <caption><h2 id="orderHistoryStatus"><?php echo HEADING_TITLE; ?></h2></caption>
      <tr class="tableHeading">
   <?php
        for ($col=0, $n=sizeof($column_list); $col<$n; $col++) {
    switch ($column_list[$col]) {
      case 'LINK_LIST_IMAGE':
        echo '<th id="linkheader center">' . TABLE_HEADING_LINKS_TITLE . '</th>';
        break;
      case 'LINK_LIST_DESCRIPTION':
        echo '<th id="linkheader left">' . TABLE_HEADING_LINKS_DESCRIPTION . '</th>';
        break;
      case 'LINK_LIST_COUNT':
        echo (LINK_LIST_COUNT == 0) ? '':'<th id="linkheader right">&nbsp;&nbsp;' . TABLE_HEADING_LINKS_COUNT . '&nbsp;&nbsp;</th>';
        break;
    }
  }
   ?>
     </tr>
  <?php 
	 while (!$listing_query->EOF) {
      $rows++;
      if (($rows/2) == floor($rows/2)) {
        echo '<tr class="productListing-even" >';
      } else {
        echo '<tr class="productListing-odd" >';
      }
      $cur_row = sizeof($list_box_contents) - 1;
      for ($col=0, $n=sizeof($column_list); $col<$n; $col++) {
        
        switch ($column_list[$col]) {
          case 'LINK_LIST_IMAGE': ?>
          <td><?php if (zen_not_null($listing_query->fields['links_image_url'])) {
              echo '<div class="listingLinksImage"><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . zen_links_image(DIR_WS_IMAGES . $listing_query->fields['links_image_url'], $listing_query->fields['links_title'], LINK_IMAGE_WIDTH, LINK_IMAGE_HEIGHT) . '</a></div>';
            } else {
              echo '<div >' . zen_links_image(DIR_WS_IMAGES . $listing_query->fields['links_image_url'], $listing_query->fields['links_title'], LINK_IMAGE_WIDTH, LINK_IMAGE_HEIGHT, 'class="listingLinksImage"') . '</div>';
            } ?></td>
         <?php break;   
           case 'LINK_LIST_DESCRIPTION':  ?>
          <td><?php  if (DISPLAY_LINK_DESCRIPTION_AS_LINK == 'true') {
            echo '<h3><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . $listing_query->fields['links_title'] . '</a></h3><div class="listingDescription"><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . nl2br($listing_query->fields['links_description']) . '</a></div>';
             } else {
           echo '<h3><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . $listing_query->fields['links_title'] . '</a></h3><div class="listingDescription">' . nl2br($listing_query->fields['links_description']) . '</div>'; } ?>
           </td>
          <?php break;
          case 'LINK_LIST_COUNT': 
            echo (LINK_LIST_COUNT == 0) ? '':'<td><div id="center">' . $listing_query->fields['links_clicked'] . '</div></td>';
         break;
        }
      }
      echo '</tr>';
       	 $listing_query->MoveNext();
    }

  ?>
  </table>
  <?php
    } else {  //Columnar Display
 $listing_query = $db->Execute($listing_split->sql_query);
 $num_links_count = $listing_split->number_of_rows;
 
      $rows = 0;
  while (!$listing_query->EOF) {
   $rows++;
   $width = (int)(100 / MAX_LINKS_ROW - 1.5) . '%';
      $newrow = false;
      if ((($rows / MAX_LINKS_ROW) == floor($rows / MAX_LINKS_ROW)) && ($rows != $num_links_count))
      {
        $newrow = true;
      }
   
    echo  '<div class="centerBoxContentsLinks centeredContentLinks back"' . ' style="width:' . $width . ';">';
    for ($col=0, $n=sizeof($column_list); $col<$n; $col++) {
        
        switch ($column_list[$col]) {
          case 'LINK_LIST_IMAGE': 
     if (zen_not_null($listing_query->fields['links_image_url'])) {
              echo '<a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . zen_links_image(DIR_WS_IMAGES . $listing_query->fields['links_image_url'], $listing_query->fields['links_title'], LINK_IMAGE_WIDTH, LINK_IMAGE_HEIGHT, 'class="listingLinksImage"') . '</a>';
            } else {
              echo zen_links_image(DIR_WS_IMAGES . $listing_query->fields['links_image_url'], $listing_query->fields['links_title'], LINK_IMAGE_WIDTH, LINK_IMAGE_HEIGHT, 'class="listingLinksImage"');
            } 
            break;
            case 'LINK_LIST_DESCRIPTION': 
           if (DISPLAY_LINK_DESCRIPTION_AS_LINK == 'true') {
            echo '<h3><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . $listing_query->fields['links_title'] . '</a></h3><div class="listingDescription"><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . nl2br($listing_query->fields['links_description']) . '</a></div>';
             } else {
           echo '<h3><a href="' . zen_get_links_url($listing_query->fields['links_id']) . '" target="_blank">' . $listing_query->fields['links_title'] . '</a></h3><div class="listingDescription">' . nl2br($listing_query->fields['links_description']) . '</div>'; } 
           break;
          case 'LINK_LIST_COUNT': 
            echo ($listing_query->fields['links_clicked'] > 1) ? '<div id="center">Total Clicks: ' . $listing_query->fields['links_clicked'] . '</div>':'<div id="center">Total Click: ' . $listing_query->fields['links_clicked'] . '</div>';
          break;
         }
       }
   echo '</div>' . "\n"; 
if ($newrow) { ?>
 <br class="clearBoth" />
<?php 
     }
   $listing_query->MoveNext();
  }
   }
  } else {
   
   echo '<h3 >' . TEXT_NO_LINKS . '</h3>';
   
  }
// end

  if ( ($listing_split->number_of_rows > 0) && ((PREV_NEXT_BAR_LOCATION == '2') || (PREV_NEXT_BAR_LOCATION == '3')) ) {
?>
<br class="clearBoth" />
    <div class="smallText"><?php echo $listing_split->display_count(TEXT_DISPLAY_NUMBER_OF_LINKS); ?></div>
    <div class="smallText" align="right"><?php echo TEXT_RESULT_PAGE . ' ' . $listing_split->display_links(MAX_DISPLAY_PAGE_LINKS, zen_get_all_get_params(array('page', 'info', 'x', 'y'))); ?></div>

<?php
  }
?>
