<?php
/**
 * Links Template
 *
 * @package templateSystem
 * @copyright Copyright 2003-2005 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: tpl_links_submit_default.php 3.5.3 4/16/2010 Clyde Jones $
 *
 * @version $Id: tpl_links_submit_default.php  3.7.0 5/14/2016 davewest $
 */
?>

<div class="centerColumn" id="ezPageDefault">
   
<?php echo zen_draw_form('submit_link', zen_href_link(FILENAME_LINKS_SUBMIT, 'action=send', $request_type), 'post',  'onsubmit="return check_form(submit_link);" enctype="multipart/form-data"'); ?>

<?php if (LINKS_STORE_NAME_ADDRESS == 'true') { ?>
<address><?php echo nl2br(STORE_NAME_ADDRESS); ?></address>
<?php } ?>

<?php
  if (isset($_GET['action']) && ($_GET['action'] == 'success')) {
?>

<div class="mainContent success"><?php echo LINKS_SUCCESS; ?></div>
<div class="buttonRow back"><?php echo zen_back_link() . zen_image_button(BUTTON_IMAGE_BACK, BUTTON_BACK_ALT) .'</a>'; ?></div>


<?php
  } else {
?>

<?php if (DEFINE_LINKS_STATUS >= '1' and DEFINE_LINKS_STATUS <= '2') { ?>
<div id="pageThreeMainContent">
<?php
require($define_page);
?>
</div>
<?php } ?>



<fieldset>
<legend><?php echo NAVBAR_TITLE_2; ?></legend>
<?php if ($messageStack->size('submit_link') > 0) echo $messageStack->output('submit_link'); ?>

<div class="forward">
<?php
if (function_exists('zen_colorbox') && ZEN_COLORBOX_STATUS == 'true') { ?>
<a class="iframe forward" href=" <?php echo zen_href_link(FILENAME_POPUP_LINKS_HELP,  '', $request_type) ; ?> " target="_blank"><?php echo zen_image_button(BUTTON_IMAGE_LINK_HELP, BUTTON_LINK_HELP_ALT); ?></a>
<?php } else { ?>
<a class="forward" href="javascript:popupWindow('<?php echo zen_href_link(FILENAME_POPUP_LINKS_HELP,  '', $request_type) ; ?>')"><?php echo zen_image_button(BUTTON_IMAGE_LINK_HELP, BUTTON_LINK_HELP_ALT); ?></a>
<?php }
?>

</div> 
<div class="alert back">        </div>
<br class="clearBoth" />
<fieldset>
<legend><?php echo CATEGORY_CONTACT; ?></legend>

<label class="inputLabel" for="contactname"><?php echo ENTRY_LINKS_CONTACT_NAME; ?></label>
<?php echo zen_draw_input_field('contactname', $links_contact_name, 'size="18" id="contactname" placeholder="' . ENTRY_REQUIRED_SYMBOL . '" required'); ?>
<br class="clearBoth" />

<label class="inputLabel" for="links_contact_email"><?php echo ENTRY_EMAIL_ADDRESS; ?></label>
<?php echo zen_draw_input_field('links_contact_email', $links_contact_email, 'size="18" id="links_contact_email" autocomplete="off" placeholder="' . ENTRY_REQUIRED_SYMBOL . '" required', 'email'); ?>
<br class="clearBoth" />

</fieldset>
<fieldset>
<legend><?php echo CATEGORY_WEBSITE; ?></legend>

<label class="inputLabel" for="links_title"><?php echo ENTRY_LINKS_TITLE; ?></label>
<?php echo zen_draw_input_field('links_title', $links_title, 'size="18" id="links_title"' . ((int)ENTRY_LINKS_TITLE_MIN_LENGTH != 0 ? ' placeholder="' .ENTRY_REQUIRED_SYMBOL . '" required' : ''), 'text'); ?>
<br class="clearBoth" />

<label class="inputLabel" for="links_url"><?php echo ENTRY_LINKS_URL; ?></label>
<?php echo zen_draw_input_field('links_url', 'http://', 'size="18" id="links_url"' . ((int)ENTRY_LINKS_URL_MIN_LENGTH > 0 ? ' placeholder="' .ENTRY_REQUIRED_SYMBOL . '" required' : '' )); ?>
<br class="clearBoth" />

<?php echo ENTRY_LINKS_CATEGORY_INFO;?>
<label class="inputLabel" for="links_category"><?php echo ENTRY_LINKS_CATEGORY; ?></label>
<?php echo zen_draw_pull_down_menu('links_category', $categories_array, $default_category, 'id="links_category" required');?>
<br class="clearBoth" />
<br class="clearBoth" />

<?php echo ENTRY_LINKS_DESCRIPTION_INFO; ?>
<label class="inputLabel" for="links_description"><?php echo ENTRY_LINKS_DESCRIPTION; ?></label>
<?php echo zen_draw_textarea_field('links_description', '20', '5', $links_description, 'id="links_url" wrap="virtual"' . ((int)ENTRY_LINKS_DESCRIPTION_MIN_LENGTH != 0 ? ' placeholder="' . ENTRY_REQUIRED_SYMBOL . '" required' : ''), 'text'); ?>
<br class="clearBoth" />

<?php if (SHOW_LINKS_BANNER_IMAGE == 'true') { ?>
<?php echo ENTRY_LINKS_BANNER_INFO;?>
<label class="inputLabel" for="links_image_url"><?php echo ENTRY_LINKS_BANNER; ?></label>
<?php echo zen_draw_file_field('links_image_url'); ?>
<?php
  }
?>
</fieldset>    
<br class="clearBoth" /> 
<?php if (SUBMIT_LINK_REQUIRE_RECIPROCAL == 'true') { ?>
<fieldset>
<legend><?php echo CATEGORY_RECIPROCAL; ?></legend>
<label class="inputLabel" for="links_reciprocal_url"><?php echo ENTRY_LINKS_RECIPROCAL_URL; ?></label>
<?php echo zen_draw_input_field('links_reciprocal_url', 'http://', 'size="18" id="links_reciprocal_url" required', 'url'); ?>

<?php echo zen_draw_input_field('should_be_empty', '', ' size="40" id="CUAS" style="visibility:hidden; display:none;" autocomplete="off"'); ?>
</fieldset>
<?php
  }
?>
</fieldset>
<div class="buttonRow back"><?php echo zen_back_link() . zen_image_button(BUTTON_IMAGE_BACK, BUTTON_BACK_ALT) .'</a>'; ?></div>
<div class="buttonRow forward">
<?php 
if (BOX_DISPLAY_SUBMIT_LINK == 'true') { 
 echo zen_image_submit(BUTTON_IMAGE_SUBMIT_LINK, BUTTON_SUBMIT_LINK_ALT); 
}else{
  echo 'Sorry, not taking Links at this time.';
} ?>
</div>

<?php
  }
?>
</form>
<br class="clearBoth" />

</div>
